object OfficerTypes;

//=======================| OFFICERS |=======================//
#define OFFIC_TYPE_REGCAP 		"captain"// NK -->
#define OFFIC_TYPE_CAPMERCHANT	"merchant captain"
#define OFFIC_TYPE_CAPPRIVATEER	"privateer captain" // PB
#define OFFIC_TYPE_CAPNAVY 		"navy captain"
#define OFFIC_TYPE_CAPPIRATE	"pirate captain"
#define OFFIC_TYPE_RANDCHAR 	"fighter"
#define OFFIC_TYPE_CIVILIAN 	"civilian"// NK <--
#define OFFIC_TYPE_BOATSWAIN 	"boatswain"
#define OFFIC_TYPE_CANNONEER 	"cannoneer"
#define OFFIC_TYPE_QMASTER 		"quartermaster"
#define OFFIC_TYPE_NAVIGATOR 	"navigator"
#define OFFIC_TYPE_FIRSTMATE 	"first mate"
#define OFFIC_TYPE_CARPENTER 	"carpenter"// MAXIMUS -->
#define OFFIC_TYPE_DOCTOR 		"doctor"
#define OFFIC_TYPE_ABORDAGE 	"deck fighter"// MAXIMUS <--
#define OFFIC_TYPE_TRADER		"trader" // KK
#define OFFIC_TYPE_GUARD		"guard" // Levis
#define OFFIC_TYPE_SHOPKEEPER	"shop merchant" // Levis

void InitOfficerTypes()
{
	//Set Personal Perk
	OfficerTypes.Combat.perks.BasicDefence = 1;
	OfficerTypes.Combat.perks.AdvancedDefence = 1;
	OfficerTypes.Combat.perks.Toughness = 1;
	OfficerTypes.Combat.perks.CriticalHit = 1;
	OfficerTypes.Combat.perks.SwordplayProfessional = 1;
	OfficerTypes.Combat.perks.Gunman = 1;
	OfficerTypes.Combat.perks.GunProfessional = 1;
	OfficerTypes.Combat.perks.ImproveAiming = 1;
	OfficerTypes.Combat.perks.GunFighter = 1;
	OfficerTypes.Combat.perks.Rush = 1;

	string type = OFFIC_TYPE_RANDCHAR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 2;
	OfficerTypes.(type).skills.Fencing.importance = 8;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 1;
	OfficerTypes.(type).skills.Accuracy.importance = 4;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).CanRand = 1;
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.(type).perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	
	type = OFFIC_TYPE_CIVILIAN;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).CanRand = 1;
	//Just some perks for him so he looks less pathetic
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	
	//This one is used for shopkeepers
	type = OFFIC_TYPE_SHOPKEEPER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 2;
	OfficerTypes.(type).skills.Commerce.importance = 10;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 4;
	OfficerTypes.(type).CanRand = 1;
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("BasicLandOwner")) {OfficerTypes.(type).perks.BasicLandOwner = 1};
	
	//This one is used for townguards
	type = OFFIC_TYPE_GUARD;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 10;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 4;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 4;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.(type).perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	
	type = OFFIC_TYPE_CAPMERCHANT;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 8;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Repair.importance = 3;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 2;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Commerce.importance = 6;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 3;
	OfficerTypes.(type).notcontribute = 1;
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.(type).perks.SandbankManeuver = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("SailingProfessional")) {OfficerTypes.(type).perks.SailingProfessional = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.(type).perks.InstantRepair = 1};
	if(isPerkExisting("Cooking")) {OfficerTypes.(type).perks.Cooking = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	
	type = OFFIC_TYPE_CAPNAVY;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Leadership.importance = 8;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 4;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 6;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 2;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Cannons.importance = 3;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).notcontribute = 1;
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("ShipDefenceProfessional")) {OfficerTypes.(type).perks.ShipDefenceProfessional = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.(type).perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("CannonProfessional")) {OfficerTypes.(type).perks.CannonProfessional = 1};
	if(isPerkExisting("Troopers")) {OfficerTypes.(type).perks.Troopers = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};
	
	type = OFFIC_TYPE_CAPPIRATE;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 10;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 3;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 3;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Cannons.importance = 5;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Grappling.importance = 8;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).notcontribute = 1;
	OfficerTypes.(type).CanRand = 1;
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.(type).perks.MusketsShoot = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.(type).perks.Brander = 1};

	//Boatswain
	type = OFFIC_TYPE_BOATSWAIN;
	OfficerTypes.(type).skills.Leadership = 1;
	OfficerTypes.(type).skills.Leadership.importance = 5;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Leadership.importance = 3;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 2;
	OfficerTypes.(type).skills.Grappling.importance = 10;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	OfficerTypes.(type).CanRand = 1;
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("InstantBoarding")) {OfficerTypes.(type).perks.InstantBoarding = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.(type).perks.MusketsShoot = 1};
	
	//Cannoneer
	type = OFFIC_TYPE_CANNONEER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 4;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 2;
	OfficerTypes.(type).skills.Accuracy.importance = 10;
	OfficerTypes.(type).skills.Cannons = 2;
	OfficerTypes.(type).skills.Cannons.importance = 10;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("ImmediateReload")) {OfficerTypes.(type).perks.ImmediateReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.(type).perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("CannonProfessional")) {OfficerTypes.(type).perks.CannonProfessional = 1};
	
	//Quarter Master - Master Purser in fact.
	type = OFFIC_TYPE_QMASTER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 2;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 1;
	OfficerTypes.(type).skills.Repair.importance = 4;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 2;
	OfficerTypes.(type).skills.Commerce.importance = 10;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 4;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("Cooking")) {OfficerTypes.(type).perks.Cooking = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("BasicLandOwner")) {OfficerTypes.(type).perks.BasicLandOwner = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	if(isPerkExisting("AdvanceSmuggling")) {OfficerTypes.(type).perks.AdvanceSmuggling = 1};
	
	
	//Navigator - what is he supposed to do, exactly?...
	type = OFFIC_TYPE_NAVIGATOR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 3;
	OfficerTypes.(type).skills.Sailing = 2;
	OfficerTypes.(type).skills.Sailing.importance = 10;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;			// set from 0 to 1 by El Rapido Set back to 0 by Levis to balance
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 1;				// set to 1 for compensation of leadership
	OfficerTypes.(type).skills.Sneak.importance = 4;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("Turn180")) {OfficerTypes.(type).perks.Turn180 = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.(type).perks.SandbankManeuver = 1};
	if(isPerkExisting("SailingProfessional")) {OfficerTypes.(type).perks.SailingProfessional = 1};
	
	//First Mate
	type = OFFIC_TYPE_FIRSTMATE;
	OfficerTypes.(type).skills.Leadership = 2;
	OfficerTypes.(type).skills.Leadership.importance = 10;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 3;
	OfficerTypes.(type).skills.Sailing = 1;
	OfficerTypes.(type).skills.Sailing.importance = 5;
	OfficerTypes.(type).skills.Accuracy = 1;			// Set to 1 to balance for few perks
	OfficerTypes.(type).skills.Accuracy.importance = 5;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	// TODO: keep IronWill or not?
	// seems to be personal skill...
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.(type).perks.Brander = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	
	//Carpenter
	type = OFFIC_TYPE_CARPENTER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 2;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 2;
	OfficerTypes.(type).skills.Repair.importance = 10;
	OfficerTypes.(type).skills.Defence = 1;
	OfficerTypes.(type).skills.Defence.importance = 5;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.(type).perks.InstantRepair = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};    // added by El Rapido
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	
	//Doctor
	type = OFFIC_TYPE_DOCTOR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 2;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 2;
	OfficerTypes.(type).skills.Defence.importance = 10;
	OfficerTypes.(type).skills.Commerce = 0;		// set to 0 by Levis
	OfficerTypes.(type).skills.Sneak = 2;			// set from 0 to 1 by El Rapido*/ Set to 2 by Levis to compensate for few perks
	OfficerTypes.(type).skills.Sneak.importance = 8;
	OfficerTypes.(type).usableoffictype = true;
	OfficerTypes.(type).CanRand = 1;
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.(type).perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("ShipDefenceProfessional")) {OfficerTypes.(type).perks.ShipDefenceProfessional = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};

	type = OFFIC_TYPE_ABORDAGE;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 10;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 4;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 2;		// set to 2 from 1 to balance by Levis
	OfficerTypes.(type).skills.Grappling.importance = 10;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 4;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	OfficerTypes.(type).CanRand = 1;
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("InstantBoarding")) {OfficerTypes.(type).perks.InstantBoarding = 1};
	if(isPerkExisting("Troopers")) {OfficerTypes.(type).perks.Troopers = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	
	//Officer which unlocked his mind
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.SuperOfficer.perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.SuperOfficer.perks.DefendPoison = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.SuperOfficer.perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.SuperOfficer.perks.ShipSpeedUp = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.SuperOfficer.perks.SandbankManeuver = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.SuperOfficer.perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.SuperOfficer.perks.AdvancedBattleState = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.SuperOfficer.perks.FastReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.SuperOfficer.perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.SuperOfficer.perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.SuperOfficer.perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.SuperOfficer.perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.SuperOfficer.perks.LongRangeGrappling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.SuperOfficer.perks.MusketsShoot = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.SuperOfficer.perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.SuperOfficer.perks.InstantRepair = 1};
	if(isPerkExisting("Cooking")) {OfficerTypes.SuperOfficer.perks.Cooking = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.SuperOfficer.perks.HighStakes = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.SuperOfficer.perks.ImproveSmuggling = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.SuperOfficer.perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.SuperOfficer.perks.AdvancedCommerce = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.SuperOfficer.perks.SharedExperience = 1};
	if(isPerkExisting("IronWill")) {OfficerTypes.SuperOfficer.perks.IronWill = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.SuperOfficer.perks.Brander = 1};
}

String GetRandomNPCType()
{
	string retVal = "";
	int numtypes = GetAttributesNum(OfficerTypes);
	int picked;
	int attempts = 0;
	string type;
	while(retVal == "")
	{
		picked = rand(numtypes-1);
		type = GetAttributeName(GetAttributeN(OfficerTypes,picked));
		if(CheckAttribute(OfficerTypes,type+".CanRand"))
		{
			retVal = type;
		}
		if(attempts>10) retVal = OFFIC_TYPE_RANDCHAR;
		else attempts ++;
	}
	return type;
}

String GetRandomOfficerType()
{
	string retVal = "";
	int numtypes = GetAttributesNum(OfficerTypes);
	int picked;
	int attempts = 0;
	string type;
	while(retVal == "")
	{
		picked = rand(numtypes-1);
		type = GetAttributeName(GetAttributeN(OfficerTypes,picked));
		if(CheckAttribute(OfficerTypes,type+".usableoffictype"))
		{
			retVal = type;
		}
		if(attempts>10) retVal = OFFIC_TYPE_ABORDAGE;
		else attempts ++;
	}
	return type;
}

bool UsableOfficer(ref _refEnemy)
{
	if(CheckAttribute(_refEnemy,"quest.officertype"))
	{
		if(!CheckAttribute(OfficerTypes,_refEnemy.quest.officertype)) 
		{
			trace("OFFIC TYPE ERROR: Type "+_refEnemy.quest.officertype+" not present");
		}
		else
		{
			if(CheckAttribute(OfficerTypes,_refEnemy.quest.officertype+".usableoffictype"))
			{
				return true;
			}
		}
	}
	return false;
}

int FindFreeRandomOfficer()
{
	// this function rewritten by KAM so new officers don't keep overwriting captains on shore leave [changes made by MAXIMUS 07.10.2007]

	for(int tempnum=0; tempnum<=NUM_RANDOM_OFFICERS; tempnum++) // NK 05-03-30 we now use char not exist to stop loop, so we can have any number of enc_off.
	{
		string tempid = "Enc_Officer_" + tempnum;
		int tempidx = GetCharacterIndex(tempid);
		if(tempidx==-1) break; // NK 05-03-30 ditto
		ref tempChar = GetCharacter(tempidx);

		if(bAllies(tempChar)) { continue; }
		if(tempChar.location == loadedLocation.id) { continue; } // PB: To prevent prospective officers from disappearing when you're talking to them

		ClearCharacter(tempChar); // PB: Completely erase the unused character

		return tempidx;
	}

	return -1;
}

int GetEffectiveSkill(ref character, string skillName)
{
	int skillPoints = GetCharacterSkill(character, skillName);
	return GetEffectiveSkillByValue(character, skillName, skillPoints);
}

int CalcEffectiveSkill(ref Character, string skillName)
{
	int skillPoints = CalcCharacterSkill(character, skillName);
	return GetEffectiveSkillByValue(character, skillName, skillPoints);
}

int GetEffectiveSkillByValue(ref character, string skillName, int skillPoints)
{
	// TODO: do we need to check main char or is it included in companions?
	// seems as if main char is companion 0...
	if(IsCompanion(character) || skillName == SKILL_FENCING)
	{
		return skillPoints;
	}

	if(CheckAttribute(character, "quest.officerType"))
	{
		int skillFactor;
		string officType = character.quest.officerType;
		if(CheckAttribute(OfficerTypes, officType))
			skillFactor = sti(OfficerTypes.(officType).skills.(skillName)); // KK
		else
			skillFactor = 2;
		// factor: can be 0, 1, 2:
		// 1: half contribution
		// 2: full contribution
		
		// calculate result = points * factor / 2
		// two variants: floor(result) or ceil(result)
		
		// this one corresponds to floor(result)
		// return skillPoints * skillFactor / 2;
		
		// this one corresponds to ceil(result)
		return (skillPoints * skillFactor + 1) / 2;
	}
	
	return 0;
}

// Aconcagua: return int:
// > 0: cost of selected perk
// < 0: could not assign perk
/*int selectPerkForOfficerType(ref character, string officerType, int freePoints)
{
	aref allPerks;
	aref chrPerks;
	makearef(allPerks, OfficerTypes.(officerType).perks);
	makearef(chrPerks, character.perks.list);

	int num = GetAttributesNum(allPerks);
    object assignablePerks;
	int n;
	string perk;
	for(n = 0; n < num; n++)
	{
		perk = GetAttributeName(GetAttributeN(allPerks, n));
		if(isPerkAssignableNoLock(character, perk, freePoints))
		{
			//Check if the main character has the perk already unlocked
			if(!CheckCharacterPerkLocked(GetMainCharacter(), perk))
			{
				UnlockPerkCharacter(character, perk); //Unlock it so it will be shown right in the display
				assignablePerks.list.(perk) = 1;
			}
			else
			{
				//If not then there is a change we unlock it.
				int rank = 0;
				if(CheckAttribute(character,"rank")) rank = character.rank;
				//At level 25 all perks should be available for the officer if the player still doesn't have them
				if(rand(50)<pow(rank,1.2))
				{
					assignablePerks.list.(perk) = 1;
				}
			}
		}
	}

	makearef(allPerks, assignablePerks.list);
	num = GetAttributesNum(allPerks);
	if(num == 0)
		return 0;

	n = Rand(num - 1);
	perk = GetAttributeName(GetAttributeN(allPerks, n));
	character.perks.list.(perk) = 1;
	UnlockPerkCharacter(character, perk); //In case it was one of the locked perks
	return GetPerkCost(perk);
}*/

void UseAyahuasca(ref officer)
{
	float a,b,c;
	GetCharacterPos(officer, &a, &b, &c);
	int action = rand(100);
	if(action<=5) //5% chance
	{
		//Kill the officer
		CreateParticleSystem("fire" , a, b+0.0, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+0.4, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+0.8, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+1.2, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+1.6, c, 0.0, 0.0, 0.0, 1);
		LAi_KillCharacter(officer);
		Logit(TranslateString("","Officer Got Killed"));
		return;
	}
	if(action<=35)	// 30% chance
	{
		//Poison the officer
		officer.chr_ai.poison = 150;
		Logit(TranslateString("","Officer Got Poisoned"));
		return;
	}
	if(action<=65) //30% chance
	{
		//Add XP
		int exp = (5-GetDifficulty())*pow(sti(officer.rank),0.5)*(rand(7)+3)*1800
		AddCharacterExpNS(officer, exp);
		Logit(TranslateString("","Officer Got Experience"));
		return;
	}
	if(action<=75) //10% Chance
	{
		//Unlock mind
		CreateParticleSystem("stars_short" , a, b+1.0, c, 0.0, 0.0, 0.0, 1);
		MakeSuperOfficer(officer);
		Logit(TranslateString("","Officer Got Unlocked"));
		return;
	}
	//else do nothing
	Logit(TranslateString("","Nothing happened"));
	return;
}

bool MakeSuperOfficer(ref officer)
{
	if(!CheckAttribute(officer,"unlocked_mind"))
	{
		officer.unlocked_mind = true;
		return true;
	}
	return false;
}